package gniazda;

import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.List;
import java.awt.Color;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import javax.swing.JToggleButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

interface MyListener {
	void messageReceived(String theLine);
}

class Receiver {
	private List<MyListener> ml = new ArrayList<MyListener>();
	private Thread t = null;
	private int port = 0;
	private ServerSocket s = null;
	private boolean end = false;

	public void stop() {
			t.interrupt();
			try {
				s.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
	}

	public void start() {
		end = false;
		t = new Thread(new Runnable() {
			@Override
			public void run() {
				try {
					s = new ServerSocket(port);
					while (true) {
						Socket sc = s.accept();
							InputStream is = sc.getInputStream();
							InputStreamReader isr = new InputStreamReader(is);
							BufferedReader br = new BufferedReader(isr);
							String theLine = br.readLine();
							ml.forEach((item) -> item.messageReceived(theLine));
							sc.close();
						}
				} catch(SocketException e){
					// TODO - podczas przerywania wtku metoda accept zgosi wyjtek
					// z wiadomoci: socket closed
				}
				catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		t.start();
	}

	public void addMyListener(MyListener m) {
		ml.add(m);
	}

	public void removeMyListener(MyListener m) {
		ml.remove(m);
	}

	Receiver(int port) {
		this.port = port;

	}

}

public class PReceiver extends JPanel implements MyListener {

	private JTextField txtPort;
	private Receiver r = null;
	private JTextField txtMessage;

	/**
	 * Create the panel.
	 */
	public PReceiver() {

		setLayout(null);

		txtPort = new JTextField();
		txtPort.setBounds(282, 13, 62, 22);
		add(txtPort);
		// txtPort.setColumns(10);

		JLabel lblPort = new JLabel("port:");
		lblPort.setBounds(241, 16, 35, 16);
		add(lblPort);

		JToggleButton btnListen = new JToggleButton("Listen");

		btnListen.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (btnListen.isSelected()) {
					r = new Receiver(Integer.parseInt(txtPort.getText()));
					r.addMyListener(PReceiver.this);
					r.start();
				} else {
					r.stop();
				}
			}
		});
		btnListen.setBounds(265, 70, 79, 25);
		add(btnListen);
		
		JLabel lblMessage = new JLabel("message");
		lblMessage.setBounds(12, 51, 56, 16);
		add(lblMessage);
		
		txtMessage = new JTextField();
		txtMessage.setBounds(12, 71, 220, 22);
		add(txtMessage);
		//txtMessage.setColumns(10);

	}

	@Override
	public void messageReceived(String theLine) {
		txtMessage.setText(theLine);

	}
}
